import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.datatransfer.DataFlavor;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;
import javax.swing.SwingWorker;

import javazoom.jl.decoder.Bitstream;
import javazoom.jl.decoder.BitstreamException;
import javazoom.jl.decoder.Decoder;
import javazoom.jl.decoder.Header;
import javazoom.jl.decoder.JavaLayerException;
import javazoom.jl.decoder.SampleBuffer;
import javazoom.jl.player.AudioDevice;
import javazoom.jl.player.FactoryRegistry;

// JMF MP3 Plugin
// http://www.oracle.com/technetwork/java/javase/download-137625.html
public class JLayerSample extends JFrame {
	// Đ[h ~
	static final int PLAY_MODE_STOP = 0;
	// Đ[h ꎞ~
	static final int PLAY_MODE_PAUSE = 1;
	// Đ[h Đ
	static final int PLAY_MODE_PLAY = 2;

	// Đp̕ϐ
	// t@C
	String filename;
	// obt@̃obt@
	Vector<BufferModel> buffer;
	// fR[hXCO[J[
	DecodeWorker decodeWorker;
	// ĐXCO[J[
	PlayWorker playWorker;
	// foCX
	AudioDevice dev;
	// fR[_
	Decoder decoder;

	// Đ[h
	int playMode = 0;

	// SwingpϐA萔
	// {^peLXg ~
	final static String STOP = "Stop";
	// {^peLXg Đ
	final static String PLAY = "Play";
	// {^peLXg ꎞ~
	final static String PAUSE = "Pause";
	// ^Cg
	final static String TITLE = "JLayermp3Đ";
	final static String FILE_NAME = "t@CF";
	// Đ{^
	JButton bPlay;
	// Ȗx
	JLabel label;

	// obt@f
	class BufferModel {
		// RXgN^ SampleBufferobt@ƃobt@̒擾oɕۑ܂B
		public BufferModel(SampleBuffer output) {
			// ㏑̂ŃN[܂B
			buffer = output.getBuffer().clone();
			length = output.getBufferLength();
		}

		// obt@
		public short[] buffer;
		// obt@̒
		public int length;
	}

	public static void main(String[] args) {
		new JLayerSample();
	}

	// RXgN^
	public JLayerSample() {
		setTitle(TITLE);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setBounds(200, 100, 300, 100);
		setLayout(new FlowLayout());

		// hbv^[Qbgݒ
		new DropTarget(this, DnDConstants.ACTION_COPY,
				new MyDropTargetListener());

		// obt@̃obt@
		buffer = new Vector<BufferModel>();

		// fR[hXbhJn
		decodeWorker = new DecodeWorker();
		decodeWorker.execute();

		// ĐXbhJn
		playWorker = new PlayWorker();
		playWorker.execute();

		// xݒu
		label = new JLabel("@mp3t@ChbvĂB");
		label.setPreferredSize(new Dimension(getWidth() - 10, 20));
		add(label);
		add(getHr(2000, 0));

		// ĐA~{^ݒu
		bPlay = new JButton(PLAY);
		bPlay.addActionListener(new bPlayAction());
		JButton bStop = new JButton(STOP);
		bStop.addActionListener(new bStopAction());
		add(bPlay);
		add(bStop);

		setVisible(true);

		addComponentListener(new ComponentAdapter() {
			// EBhETCYω烉x̃TCYύX
			@Override
			public void componentResized(ComponentEvent e) {
				label.setPreferredSize(new Dimension(getWidth() - 10, 20));
			}
		});

	}

	// 
	public JSeparator getHr(int width, int hight) {
		JSeparator sp = new JSeparator(JSeparator.HORIZONTAL);
		sp.setPreferredSize(new Dimension(width, hight));
		return sp;
	}

	// Đ{^̃ANVNX
	class bPlayAction implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			// System.out.println("mode = " + playMode);
			if (playMode == PLAY_MODE_PAUSE) {
				// ꎞ~̏ꍇAꎞ~܂
				noPause();
			} else if (playMode == PLAY_MODE_STOP) {
				// ~̏ꍇAĐJn܂
				play();
			} else if (playMode == PLAY_MODE_PLAY) {
				// Đ̏ꍇAꎞ~܂
				pause();
			}
		}
	}

	// ~{^̃ANVNX
	class bStopAction implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			stop();
		}
	}

	// ꎞ~
	private void pause() {
		playMode = PLAY_MODE_PAUSE;
		bPlay.setText(PLAY);
	}

	// ꎞ~
	private void noPause() {
		playMode = PLAY_MODE_PLAY;
		bPlay.setText(PLAY);
	}

	// Đ
	private void play() {
		decodeWorker.decodePause();
		decodeWorker.decodeInit();
		playMode = PLAY_MODE_PLAY;
		bPlay.setText(PAUSE);
	}

	// ~
	private void stop() {
		playMode = PLAY_MODE_STOP;
		bPlay.setText(PLAY);
	}

	// fR[h[J[Xbh
	// fR[_NX𕠎āAfR[h[vĂяo
	// fR[_NX̃|[YƏ𒆌p܂
	class DecodeWorker extends SwingWorker<Object, Object> {
		public MyDecoder myDecoder = new MyDecoder();

		// fR[h[vĂяo܂
		@Override
		protected Object doInBackground() throws Exception {
			myDecoder.decodeRoop();
			return null;
		}

		// fR[_NX̃|[YĂяo܂
		public void decodePause() {
			myDecoder.pause();
		}

		// fR[_NX̏Ăяo܂
		public void decodeInit() {
			myDecoder.init();
		}
	}

	// fR[_[NX
	class MyDecoder {
		private Bitstream bitstream;
		public InputStream stream;
		// fR[htO
		boolean decodeFlg = false;

		// fR[h~
		public void pause() {
			decodeFlg = false;
		}

		// fR[_[܂
		void init() {
			// System.out.println("decodeInit start");
			try {
				// fR[h~
				decodeFlg = false;
				// obt@NA
				buffer.clear();
				// Xg[N[Y
				closeStream();
				// fR[_̏
				openDevice();

				// CvbgXg[擾
				stream = getInputStream();
				if (stream == null) {
					return;
				}
				bitstream = new Bitstream(stream);
				// fR[hĊJ
				decodeFlg = true;
			} catch (Exception e) {
				e.printStackTrace();
				throw new RuntimeException(e);
			}
			// System.out.println("decodeInit end");
		}

		// foCX擾
		private void openDevice() throws JavaLayerException {
			try {
				if (dev != null) {
					// foCXnullłȂ΁AN[Y
					dev.flush();
					dev.close();
				}
				// foCX擾
				dev = getAudioDevice();
			} catch (JavaLayerException e) {
				// foCX擾łȂꍇG[
				e.printStackTrace();
				JOptionPane.showMessageDialog(null,
						"foCX擾ł܂łB" + e.getMessage(), TITLE + " G[",
						JOptionPane.WARNING_MESSAGE);
				System.exit(1);
			}
			// fR[_[𐶐ĊJ
			decoder = new Decoder();
			dev.open(decoder);
		}

		// fR[h[v
		// G[NĂ邮葱fR[h܂
		// fR[htOtrueAĐ[h~Aobt@̃TCY100ȏ̂ꂩ̏ꍇ
		// fR[hȂŃ[v񂵂܂
		void decodeRoop() {
			decodeFlg = true;
			// int i = 0;
			while (true) {
				try {
					if (decodeFlg && playMode != PLAY_MODE_STOP
							&& buffer.size() < 100) {
						if (!decordOneFrame()) {
							// System.out.println("ȂɂG[H");
						}
					}

					// fobOp̃Oo
					// i++;
					// if (i % 1000 == 0) {
					// System.out.println("i = " + i + ", buffer.size = " +
					// buffer.size());
					// }

					Thread.sleep(1);
				} catch (Exception e) {
					e.printStackTrace();
					// G[Ԃ
				}
			}
		}

		// Xg[N[Y
		void closeStream() {
			try {
				if (bitstream != null) {
					// N[Y
					bitstream.close();
					bitstream = null;
				}
			} catch (BitstreamException e) {
				// O͈Ԃ
			}
		}

		// CvbgXg[擾
		protected InputStream getInputStream() throws IOException {
			if (filename == null) {
				return null;
			}
			// System.out.println(filename);
			FileInputStream fin = new FileInputStream(filename);
			BufferedInputStream bin = new BufferedInputStream(fin);
			return bin;
		}

		// 1t[fR[h
		private boolean decordOneFrame() {
			if (bitstream == null) {
				return false;
			}
			try {
				Header h = bitstream.readFrame();
				if (h == null) {
					return false;
				}

				SampleBuffer output = (SampleBuffer) decoder.decodeFrame(h,
						bitstream);
				if (output.getBufferLength() == 0) {
					// System.out.println("bufferSize = "
					// + output.getBufferLength());
					return false;
				}
				buffer.add(new BufferModel(output));

				bitstream.closeFrame();
			} catch (JavaLayerException ex) {
				return false;
			}
			return true;
		}
	}

	// ĐpXCO[J[
	// ĐNX𕠎āAĐ[vĂяo܂
	class PlayWorker extends SwingWorker<Object, Object> {
		MyPlayer player = new MyPlayer();

		// Đ[vĂяo܂
		@Override
		protected Object doInBackground() throws Exception {
			// System.out.println("PlayWorker#doInBackground start");
			player.playRoop();
			// System.out.println("PlayWorker#doInBackground end");
			return null;
		}
	}

	// foCX̎擾
	protected AudioDevice getAudioDevice() throws JavaLayerException {
		return FactoryRegistry.systemRegistry().createAudioDevice();
	}

	// ĐNX
	// Đ[vȂł
	class MyPlayer {
		// Đ[v
		// G[N悤悤Ɖ葱Aobt@̒gfoCXɏo͂܂
		// Đ[hĐȊOAobt@TCY0̏ꍇ͍ĐȂŎ̃[vɉ񂵂܂
		public void playRoop() {
			// System.out.println("playRoop start");
			// int j = 0;
			while (true) {
				try {
					// j++;
					// if (j % 1000 == 0) {
					// System.out.println("j = " + j);
					// }
					if (playMode != PLAY_MODE_PLAY || buffer.size() == 0) {
						Thread.sleep(1);
						continue;
					}
					// obt@̒g擾AfoCXɏ݂܂
					BufferModel model = buffer.remove(0);
					dev.write(model.buffer, 0, model.length);
					Thread.sleep(1);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}

	// hbv^[QbgXi[
	// hbvꂽt@C󂯎Aŏ̃t@CĐ܂
	class MyDropTargetListener extends DropTargetAdapter {
		@Override
		public void drop(DropTargetDropEvent dtde) {
			dtde.acceptDrop(DnDConstants.ACTION_COPY);
			boolean b = false;
			try {
				if (dtde.getTransferable().isDataFlavorSupported(
						DataFlavor.javaFileListFlavor)) {
					b = true;
					List<File> list = (List<File>) dtde.getTransferable()
							.getTransferData(DataFlavor.javaFileListFlavor);
					for (File file : list) {
						// ŏ̃t@C擾
						filename = file.getPath();
						label.setText(FILE_NAME + file.getName());

						// 擾t@CĐ
						stop();
						play();
						break;
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				dtde.dropComplete(b);
			}
		}
	}
}
